diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlabPainted.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlabPainted.java
index f1d9b455b..deef4ed75 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlabPainted.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlabPainted.java
@@ -7,7 +7,7 @@ import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -19,18 +19,18 @@ public class BlockLogicSlabPainted extends BlockLogicSlab implements IPainted
 	}
 
 	@Override
-	public int getPlacedData(@Nullable Player player, @NotNull ItemStack itemStack, @NotNull World world, @NotNull TilePos tilePos, @NotNull Side side, double xHit, double yHit) {
+	public int getPlacedData(@Nullable Player player, @NotNull ItemStack itemStack, @NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
 		return itemStack.getMetadata();
 	}
 
 	@Override
-	public void onPlacedByMob(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side, Mob mob, double xHit, double yHit) {
+	public void onPlacedByMob(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, @NotNull Mob mob, double xHit, double yHit) {
 		int meta = mob.getVerticalPlacementDirection(side, yHit) == Direction.UP ? 2 : 0;
 		world.setBlockDataNotify(tilePos, meta | (world.getBlockData(tilePos) & 0xF0));
 	}
 
 	@Override
-	public void onPlacedOnSide(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side, double xHit, double yHit) {
+	public void onPlacedOnSide(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
 		int meta = side == Side.TOP ? 2 : 0;
 		world.setBlockDataNotify(tilePos, meta | (world.getBlockData(tilePos) & 0xF0));
 	}
@@ -51,13 +51,13 @@ public class BlockLogicSlabPainted extends BlockLogicSlab implements IPainted
 	}
 
 	@Override
-	public void removeDye(@NotNull World world, @NotNull TilePos tilePos) {
+	public void removeDye(@NotNull World world, @NotNull TilePosc tilePos) {
 		final int meta = world.getBlockData(tilePos);
 		world.setBlockIdDataNotify(tilePos, Blocks.PLANKS_OAK.id(), meta & 0xF);
 	}
 
 	@Override
-	public void setColor(@NotNull World world, @NotNull TilePos tilePos, @NotNull DyeColor color) {
+	public void setColor(@NotNull World world, @NotNull TilePosc tilePos, @NotNull DyeColor color) {
 		IPainted.super.setColor(world, tilePos, color);
 	}
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSnow.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSnow.java
index b963a6726..2f9fb5b45 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSnow.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSnow.java
@@ -1,13 +1,13 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.world.World;
-import net.minecraft.core.block.material.Material;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -17,12 +17,12 @@ public class BlockLogicSnow extends BlockLogic
 {
 
 	public BlockLogicSnow(Block<?> block) {
-        super(block, Material.snow);
+        super(block, Materials.SNOW);
         block.setTicking(true);
     }
 
     @Override
-	public void updateTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand, boolean isRandomTick) {
+	public void updateTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand, boolean isRandomTick) {
         if(world.getSavedLightValue(LightLayer.Block, tilePos) > 11) {
             dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
             world.setBlockIdNotify(tilePos, 0);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSoulSand.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSoulSand.java
index 2ffc3853a..b93cf2b38 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSoulSand.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSoulSand.java
@@ -1,30 +1,31 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 public class BlockLogicSoulSand extends BlockLogic
 {
 
     public BlockLogicSoulSand(Block<?> block)
     {
-        super(block, Material.soulsand);
+        super(block, Materials.SOUL_SAND);
     }
 
     @Override
-    public @Nullable AABB getCollisionAABB(@NotNull WorldSource source, @NotNull TilePos tilePos) {
+    public @Nullable AABBdc getCollisionAABB(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
         double f = 2/16d;
-        return AABB.fromPool(tilePos.x, tilePos.y, tilePos.z, tilePos.x + 1, tilePos.y + 1 - f, tilePos.z + 1);
+        return new AABBd(tilePos.x(), tilePos.y(), tilePos.z(), tilePos.x() + 1, tilePos.y() + 1 - f, tilePos.z() + 1);
     }
 
     @Override
-    public void onEntityCollision(@NotNull World world, @NotNull TilePos tilePos, @NotNull Entity entity) {
+    public void onEntityCollision(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Entity entity) {
         entity.xd *= 0.4D;
         entity.zd *= 0.4D;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSpikes.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSpikes.java
index 3737c22a1..6f6fc42de 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSpikes.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSpikes.java
@@ -14,12 +14,13 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.world.WorldSource;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 public class BlockLogicSpikes extends BlockLogic
 {
@@ -33,7 +34,7 @@ public class BlockLogicSpikes extends BlockLogic
     }
 
     @Override
-    public void onPlacedOnSide(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side, double xHit, double yHit) {
+    public void onPlacedOnSide(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
         if (world.isClientSide) {
             return;
         }
@@ -51,7 +52,7 @@ public class BlockLogicSpikes extends BlockLogic
     }
 
 	@Override
-	public void onNeighborChanged(@NotNull World world, @NotNull TilePos tilePos, int id) {
+	public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
 		if(world.isClientSide) {
 			return;
 		}
@@ -73,13 +74,13 @@ public class BlockLogicSpikes extends BlockLogic
 
 
     @Override
-    public @Nullable AABB getCollisionAABB(@NotNull WorldSource source, @NotNull TilePos tilePos) {
+    public @Nullable AABBdc getCollisionAABB(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
         double thickness = 3/16d;
-        return AABB.fromPool(tilePos.x, tilePos.y, tilePos.z, tilePos.x + 1,tilePos.y + thickness, tilePos.z + 1);
+        return new AABBd(tilePos.x(), tilePos.y(), tilePos.z(), tilePos.x() + 1,tilePos.y() + thickness, tilePos.z() + 1);
     }
 
     @Override
-    public void onEntityCollision(@NotNull World world, @NotNull TilePos tilePos, @NotNull Entity entity) {
+    public void onEntityCollision(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Entity entity) {
         int metaData = world.getBlockData(tilePos);
         if(isSpikesUp(metaData)) {
             if (entity instanceof Mob) {
@@ -102,7 +103,7 @@ public class BlockLogicSpikes extends BlockLogic
     }
 
     @Override
-    public boolean collidesWithEntity(@NotNull Entity entity, @NotNull World world, @NotNull TilePos tilePos) {
+    public boolean collidesWithEntity(@NotNull Entity entity, @NotNull World world, @NotNull TilePosc tilePos) {
         return !(entity instanceof EntityItem);
     }
     
@@ -122,7 +123,7 @@ public class BlockLogicSpikes extends BlockLogic
     }
 
     @Override
-    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
+    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         return side == Side.BOTTOM ? FullSupport.INSTANCE : PartialSupport.INSTANCE;
     }
 }
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSponge.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSponge.java
index 58c50d1ed..2405b7b65 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSponge.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSponge.java
@@ -1,49 +1,44 @@
 package net.minecraft.core.block;
 
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.Dimension;
-import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
-public class BlockLogicSponge extends BlockLogic
-{
+public class BlockLogicSponge extends BlockLogic {
     final boolean isWet;
-	public BlockLogicSponge(@NotNull Block<?> block, boolean isWet)
-    {
-        super(block, Material.sponge);
+
+    public BlockLogicSponge(@NotNull Block<?> block, boolean isWet) {
+        super(block, Materials.SPONGE);
         this.isWet = isWet;
     }
 
     @Override
-	public void onPlacedByWorld(@NotNull World world, @NotNull TilePos tilePos)
-    {
+    public void onPlacedByWorld(@NotNull World world, @NotNull TilePosc tilePos) {
         super.onPlacedByWorld(world, tilePos);
-        if((world.dimension == Dimension.NETHER || inHot(world, tilePos)) && this.isWet){
+        if ((world.dimension == Dimension.NETHER || inHot(world, tilePos)) && this.isWet) {
             world.setBlockIdNotify(tilePos, Blocks.SPONGE_DRY.id());
-            world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, tilePos.x + 0.5D, tilePos.y + 0.5D, tilePos.z + 0.5D, "random.fizz", 0.5F, 2.6F + (world.rand.nextFloat() - world.rand.nextFloat()) * 0.8F);
-            for(int l = 0; l < 8; l++)
-            {
-                world.spawnParticle("largesmoke", (double)tilePos.x + Math.random(), (double)tilePos.y + Math.random(), (double)tilePos.z + Math.random(), 0.0D, 0.0D, 0.0D, 0);
+            world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, tilePos.x() + 0.5D, tilePos.y() + 0.5D, tilePos.z() + 0.5D, "random.fizz", 0.5F, 2.6F + (world.rand.nextFloat() - world.rand.nextFloat()) * 0.8F);
+            for (int l = 0; l < 8; l++) {
+                world.spawnParticle("largesmoke", (double) tilePos.x() + Math.random(), (double) tilePos.y() + Math.random(), (double) tilePos.z() + Math.random(), 0.0D, 0.0D, 0.0D, 0);
             }
         }
         final byte radius = 2;
-        if(!this.isWet && inWater(world, tilePos)) {
-            TilePos p = new TilePos(tilePos);
-            for (int x = tilePos.x - radius; x <= tilePos.x + radius; x++) {
-                for (int y = tilePos.y - radius; y <= tilePos.y + radius; y++) {
-                    for (int z = tilePos.z - radius; z <= tilePos.z + radius; z++) {
-                        p.x = tilePos.x;
-                        p.y = tilePos.y;
-                        p.z = tilePos.z;
-                        if (Blocks.hasTag(world.getBlockId(p), BlockTags.IS_WATER)) {
-                            world.setBlockIdNotify(p, 0);
+        if (!this.isWet && inWater(world, tilePos)) {
+            TilePos queryPos = new TilePos();
+            for (queryPos.x = tilePos.x() - radius; queryPos.x <= tilePos.x() + radius; queryPos.x++) {
+                for (queryPos.y = tilePos.y() - radius; queryPos.y <= tilePos.y() + radius; queryPos.y++) {
+                    for (queryPos.z = tilePos.z() - radius; queryPos.z <= tilePos.z() + radius; queryPos.z++) {
+                        if (Blocks.hasTag(world.getBlockId(queryPos), BlockTags.IS_WATER)) {
+                            world.setBlockIdNotify(queryPos, 0);
 
                         }
                     }
@@ -54,37 +49,35 @@ public class BlockLogicSponge extends BlockLogic
     }
 
 
-    public boolean inWater(@NotNull World world, @NotNull TilePos tilePos){
+    public boolean inWater(@NotNull World world, @NotNull TilePosc tilePos) {
+        TilePos queryPos = new TilePos();
         for (int i = 0; i < Direction.directions.length; i++) {
             Direction dir = Direction.directions[i];
-            Block<?> b = world.getBlock(tilePos.add(dir));
+            Block<?> b = world.getBlock(tilePos.add(dir, queryPos));
             if (Blocks.hasTag(b, BlockTags.IS_WATER)) return true;
         }
         return false;
     }
 
-    public boolean inHot(@NotNull World world, @NotNull TilePos tilePos){
+    public boolean inHot(@NotNull World world, @NotNull TilePosc tilePos) {
+        TilePos queryPos = new TilePos();
         for (int i = 0; i < Direction.directions.length; i++) {
             Direction dir = Direction.directions[i];
-            Block<?> b = world.getBlock(tilePos.add(dir));
+            Block<?> b = world.getBlock(tilePos.add(dir, queryPos));
             if (b == Blocks.COBBLE_NETHERRACK_IGNEOUS || Blocks.hasTag(b, BlockTags.IS_LAVA)) return true;
         }
         return false;
     }
 
     @Override
-    public void onRemoved(@NotNull World world, @NotNull TilePos tilePos, int data)
-    {
-        if(!this.isWet) {
+    public void onRemoved(@NotNull World world, @NotNull TilePosc tilePos, int data) {
+        if (!this.isWet) {
             byte radius = 2;
-            TilePos p = new TilePos(tilePos);
-            for (int x = tilePos.x - radius; x <= tilePos.x + radius; x++) {
-                for (int y = tilePos.y - radius; y <= tilePos.y + radius; y++) {
-                    for (int z = tilePos.z - radius; z <= tilePos.z + radius; z++) {
-                        p.x = x;
-                        p.y = y;
-                        p.z = z;
-                        world.notifyBlocksOfNeighborChange(p, world.getBlockId(p));
+            TilePos queryPos = new TilePos(tilePos);
+            for (queryPos.x = tilePos.x() - radius; queryPos.x <= tilePos.x() + radius; queryPos.x++) {
+                for (queryPos.y = tilePos.y() - radius; queryPos.y <= tilePos.y() + radius; queryPos.y++) {
+                    for (queryPos.z = tilePos.z() - radius; queryPos.z <= tilePos.z() + radius; queryPos.z++) {
+                        world.notifyBlocksOfNeighborChange(queryPos, world.getBlockId(queryPos));
                     }
 
                 }
@@ -94,28 +87,28 @@ public class BlockLogicSponge extends BlockLogic
     }
 
     @Override
-    public void animationTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand) {
+    public void animationTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand) {
         if (this.isWet) {
             Side side = Side.sides[rand.nextInt(6)]; // Get random side
-            if (side == Side.TOP || world.isBlockOpaqueCube(tilePos.add(side.getDirection()))) return;
+            if (side == Side.TOP || world.isBlockOpaqueCube(tilePos.add(side.getDirection(), new TilePos()))) return;
             float off1 = rand.nextFloat() * 0.9f + 0.05f;
             float off2 = rand.nextFloat() * 0.9f + 0.05f;
             float lOff = 0.1f; // Dumb offset to fix bad lighting
             switch (side) {
                 case BOTTOM:
-                    world.spawnParticle("dripWater", tilePos.x + off1, tilePos.y - lOff, tilePos.z + off2, 0, 0, 0, 0);
+                    world.spawnParticle("dripWater", tilePos.x() + off1, tilePos.y() - lOff, tilePos.z() + off2, 0, 0, 0, 0);
                     break;
                 case NORTH:
-                    world.spawnParticle("dripWater", tilePos.x + off1, tilePos.y + off2, tilePos.z - lOff, 0, 0, 0, 0);
+                    world.spawnParticle("dripWater", tilePos.x() + off1, tilePos.y() + off2, tilePos.z() - lOff, 0, 0, 0, 0);
                     break;
                 case SOUTH:
-                    world.spawnParticle("dripWater", tilePos.x + off1, tilePos.y + off2, tilePos.z + 1 + lOff, 0, 0, 0, 0);
+                    world.spawnParticle("dripWater", tilePos.x() + off1, tilePos.y() + off2, tilePos.z() + 1 + lOff, 0, 0, 0, 0);
                     break;
                 case WEST:
-                    world.spawnParticle("dripWater", tilePos.x - lOff, tilePos.y + off1, tilePos.z + off2, 0, 0, 0, 0);
+                    world.spawnParticle("dripWater", tilePos.x() - lOff, tilePos.y() + off1, tilePos.z() + off2, 0, 0, 0, 0);
                     break;
                 case EAST:
-                    world.spawnParticle("dripWater", tilePos.x + 1 + lOff, tilePos.y + off1, tilePos.z + off2, 0, 0, 0, 0);
+                    world.spawnParticle("dripWater", tilePos.x() + 1 + lOff, tilePos.y() + off1, tilePos.z() + off2, 0, 0, 0, 0);
                     break;
             }
         }
